#!/usr/bin/perl
###
$BASE=$0;
###
use Encode;
use Encode::Guess qw/euc-jp shiftjis/;
use LWP::Simple;
###
if(!-d($BASE)){
	@buf=split(/\//,$BASE);
	pop(@buf);
	$BASE=join('/',@buf);
}
chdir($BASE) if($BASE);
###
open(FILE,"config.dat");
$CONFIG=join('',<FILE>);
close(FILE);
$TOP=&GetValue($CONFIG,"TOP",'\n');
$MAX=&GetValue($CONFIG,"MAX",'\n');
$MAXCHECK=&GetValue($CONFIG,"MAXCHECK",'\n');
$MAXDEPTH=&GetValue($CONFIG,"MAXDEPTH",'\n');
@CHECK=&GetValue($CONFIG,"CHECK",'\n');
$FILTER=&GetValue($CONFIG,"FILTER",'\n');
$LAST=(stat('list.dat'))[9];
###
&GetList;
&RecordList if($UPDATE>$LAST);
exit;
###
###
sub RecordList{
	my($i,@list);
	open(FILE,"+>list.dat");
	foreach(sort {$DATE{$b} <=> $DATE{$a}} keys(%DATE)){
		print FILE "$_<${DATE{$_}}<${TITLE{$_}}<${DESCRIPTION{$_}}<${FIRST{$_}}<${AUTHOR{$_}}<${SIZE{$_}}\n";
		push(@list,$_);
		$i++;
		last if($i>=$MAX);
	}
	close(FILE);
	&MakeFile(@list);
}
###
sub MakeFile{
	my(@list,$i,$file,$top,@temp,$item,$list,@dir,$name,$max,$filter,@filter,%fvalue);
	@list=@_;
	opendir(DIR,'style');
	@dir=readdir(DIR);
	closedir(DIR);
	foreach $name(@dir){
		next if($name=~/^\./ || $name eq 'admin');
		$max=&GetValue($CONFIG,"LIST-$name",'\n');
		$filter=&GetValue($CONFIG,"FILTER-$name",'\n');
		undef(@filter);
		if($filter ne ''){
			open(FILE,"filter/$filter.dat");
			while(<FILE>){
				@temp=split(/[<\n]/);
				$temp[0]=~s/\./\\\./g;
				$temp[0]=~s/\?/\\\?/g;
				$temp[0]=~s/\*/\.\*/g;
				push(@filter,$temp[0]);
				$fvalue{$temp[0]}=$temp[1];
			}
			close(FILE);
		}
		&ReadStyle($name);
		$item='';
		$list='';
		for($i=0;$i<$max && $list[$i];$i++){
			$filter='';
			foreach(@filter){
				if($list[$i]=~/^$_$/){
					if($fvalue{$_} eq ''){
						$filter=-1;
						$max++;
					}else{
						$filter=$fvalue{$_};
					}
					last;
				}
			}
			next if($filter==-1);
			$item.=&InsertString('item',$list[$i],$TITLE{$list[$i]},$DESCRIPTION{$list[$i]},($AUTHOR{$list[$i]} || $AUTHOR),0,0,0,0,0,&DateEncode($DATE{$list[$i]}),&DateEncode($DATE{$list[$i]},1),&DateEncode($FIRST{$list[$i]}),&DateEncode($FIRST{$list[$i]},1),$filter);
			$list.=&InsertString('list',$list[$i],$TITLE{$list[$i]},$DESCRIPTION{$list[$i]},($AUTHOR{$list[$i]} || $AUTHOR),0,0,0,0,0,&DateEncode($DATE{$list[$i]}),&DateEncode($DATE{$list[$i]},1),&DateEncode($FIRST{$list[$i]}),&DateEncode($FIRST{$list[$i]},1));
		}
		$file=&InsertString('frame',$item,$list,$TOP,$TITLE{$TOP},$DESCRIPTION{$TOP},$AUTHOR{$TOP},0,0,0,&DateEncode($DATE{$TOP}),&DateEncode($DATE{$TOP},1));
		open(FILE,"+>file/$name");
		print FILE $file;
		close(FILE);
	}
}
###
sub DateEncode{
	my($i,@time);
	$i=shift;
	if(shift){
		@time=gmtime($i);
	}else{
		@time=localtime($i);
	}
	$time[5]+=1900;
	$time[4]++;
	for($i=0;$i<5;$i++){
		$time[$i]='0'.$time[$i] if(length($time[$i])==1);
	}
	$time[6]='Sun' if($time[6]==0);
	$time[6]='Mon' if($time[6]==1);
	$time[6]='Tue' if($time[6]==2);
	$time[6]='Wed' if($time[6]==3);
	$time[6]='Thu' if($time[6]==4);
	$time[6]='Fri' if($time[6]==5);
	$time[6]='Sat' if($time[6]==6);
	$time[7]='Jan' if($time[4]==1);
	$time[7]='Feb' if($time[4]==2);
	$time[7]='Mar' if($time[4]==3);
	$time[7]='Apr' if($time[4]==4);
	$time[7]='May' if($time[4]==5);
	$time[7]='Jun' if($time[4]==6);
	$time[7]='Jul' if($time[4]==7);
	$time[7]='Aug' if($time[4]==8);
	$time[7]='Sep' if($time[4]==9);
	$time[7]='Oct' if($time[4]==10);
	$time[7]='Nov' if($time[4]==11);
	$time[7]='Dec' if($time[4]==12);
	return($time[0],$time[1],$time[2],$time[3],$time[4],$time[5],$time[6],$time[7],0,0);
}
###
sub GetList{
	my($i,$root,@temp,@url,$url,%check,$depth,@head,$html,@filter,$href,$enc);
	if($FILTER ne ''){
		open(FILE,"filter/$FILTER.dat");
		while(<FILE>){
			@temp=split(/</);
			$temp[0]=~s/\./\\\./g;
			$temp[0]=~s/\?/\\\?/g;
			$temp[0]=~s/\*/\.\*/g;
			push(@filter,$temp[0]);
		}
		close(FILE);

	}
	foreach(@CHECK){
		next if(!$_);
		push(@url,$_);
		$check{$_}=1;
	}
	open(FILE,"list.dat");
	while(<FILE>){
		@temp=split(/[<\n]/);
		next if(!$temp[0]);
		$DATE{$temp[0]}=$temp[1];
		$FIRST{$temp[0]}=$temp[4];
		$SIZE{$temp[0]}=$temp[6];
		$TITLE{$temp[0]}=$temp[2];
		$DESCRIPTION{$temp[0]}=$temp[3];
		$AUTHOR{$temp[0]}=$temp[5];
	}
	close(FILE);
	$root=$TOP;
	$root=~s/\/[^\/]*$//;
	for($i=0;$i<$MAXCHECK && $url[$i];$i++){
		$url=$url[$i];
		@head=head($url);
		if($head[0]!~/text\/html/){
			delete($DATE{$url});
			next;
		}
		$html='';
		if(!$head[1]){
			$html=get($url);
			$head[1]=length($html);
			if(!$head[1]){
				delete($DATE{$url});
				next;
			}
		}
		$head[2]=time if(!$head[2] and !$DATE{$url} || $SIZE{$url}!=$head[1]);
		next if($head[2]<=$DATE{$url});
		$UPDATE=$head[2] if($UPDATE<$head[2]);
		$DATE{$url}=$head[2];
		$FIRST{$url}=$head[2] if(!$FIRST{$url});
		$SIZE{$url}=$head[1];
		$html=get($url) if(!$html);
		$enc=Encode::Guess->guess($html);
		Encode::from_to($html,$enc->name,"utf8") if(ref($enc));
		$TITLE{$url}=$1 if($html=~s/<title>([^<>]+)<\/title>//);
		$DESCRIPTION{$url}=$1 if($html=~s/<meta [^<>]*name=['"]?description['" ][^<>]*content=['"]?([^<>'"]+)[^<>]*>//);
		$AUTHOR{$url}=$1 if($html=~s/<meta [^<>]*name=['"]?author['" ][^<>]*content=['"]?([^<>'"]+)[^<>]*>//);
		$TITLE{$url}=~s/[\r\n]/ /g;
		$TITLE{$url}=~s/&nbsp;/ /g;
		$DESCRIPTION{$url}=~s/&nbsp;/ /g;
		$AUTHOR{$url}=~s/&nbsp;/ /g;
		$TITLE{$url}=~s/&/&amp;/g;
		$DESCRIPTION{$url}=~s/&/&amp;/g;
		$AUTHOR{$url}=~s/&/&amp;/g;
		next if($depth{$url}>=$MAXDEPTH);
		$base=$url;
		$base=~s/\/[^\/]*$/\//;
		while($html=~/<a [^<>]*href=['"]?([^<>'" ]+)[^<>]*>/g){
			$href=$1;
			next if($href=~/^mailto:/ || $href=~/^JavaScript:/);
			$href=~s/#.*$//;
			$href=$root.$href if($href=~/^\//);
			$href=$base.$href if($href!~/^http:\/\//);
			while($href=~/\/\.\.\//){
				$href=~s/\/[^\/]+\/\.\.\//\//g;
			}
			while($href=~/\/\.\//){
				$href=~s/\/\.\//\//g;
			}
			next if($href!~/^$root/);
			foreach(@filter){
				if($href=~/^$_$/){
					$href='';
					last;
				}
			}
			next if(!$href);
			next if($check{$href});
			push(@url,$href);
			$check{$href}=1;
			$depth{$href}=$depth{$url}+1;
			last if($#url>=$MAXCHECK);
		}
	}
}
###
sub InsertString{
	my($result);
	$result=$STYLE{$_[0]};
	$result=~s/\$SCRIPT\((\d+)\)/$_[$1]/g;
	return($result);
}
###
sub ReadStyle{
	my(@dir,$style);
	$style=$_[0] || $STYLE;
	opendir(DIR,"style/$style");
	@dir=readdir(DIR);
	closedir(DIR);
	foreach(@dir){
		if(/^(\w+)\.dat$/){
			$STYLE{$1}="";
			open(FILE,"style/$style/$1.dat");
			while(<FILE>){
				$STYLE{$1}.=$_;
			}
			close(FILE);
		}
	}
}
###
sub GetValue{
	my(@objects,$char,$str,$key,@value);
	$str=shift;
	$key=shift;
	$char=shift || '&';
	@objects=split(/$char/,$str);
	foreach(@objects){
		push(@value,$1) if(/^$key=(.*)$/);
	}
	return($value[0]) if($#value<1);
	return(@value);
}
###

